﻿Type=Class
Version=3.71
ModulesStructureVersion=1
B4J=true
@EndOfDesignText@
'Class module
Sub Class_Globals
	Private fx As JFX
	Private sockServer As ServerSocket
	Private const port As Int = 54025
	Private astream As AsyncStreams
	
	 Dim robot As AWTRobot
  	 Dim img() As Byte
	 Dim bc As ByteConverter
	 Private W,H As Int
Dim tmr As Timer
End Sub

Public Sub Initialize
	sockServer.Initialize(port, "SockServer")
	sockServer.Listen
	tmr.Initialize("tmr",2000)
	tmr.Enabled = True
	ShowIp
	w = 230
	h = 170
End Sub

Public Sub ShowIp
	If astream.IsInitialized Then
		Main.ShowNotification("TCP connector","TCP is connected", False)
	Else
		Main.ShowNotification("TCP connector", $"IP address: ${sockServer.GetMyIP}
Waiting for TCP connection.
Make sure that the following port is open in the firewall (TCP): ${port}"$, False)
	End If
End Sub

Private Sub SockServer_NewConnection (Successful As Boolean, NewSocket As Socket)
	If Successful Then
		If astream.IsInitialized Then astream.Close
		astream.InitializePrefix(NewSocket.InputStream, False, NewSocket.OutputStream, "astream")
		Main.ShowNotification("TCP connector", "Connected", False)
	End If
	sockServer.Listen
End Sub

Private Sub astream_NewData (Buffer() As Byte)
	Dim st As String = bc.StringFromBytes(Buffer,"utf8")
	Select st
		Case "reset"
			W = 230
			H = 170
		Case "in"
			W =  W / 2
			H =  H / 2
		Case "out"
			W =  W * 2
			H =  H * 2
		Case Else
			Main.Handler.HandleCommand(Buffer)
	End Select
End Sub

Private Sub astream_Terminated
	Main.ShowNotification("TCP connector", "Disconnected", True)
	astream.Close
End Sub

Private Sub astream_Error
	astream_Terminated
End Sub

Sub tmr_tick
	Dim m() As Int = robot.RobotMouseCurrentLocation()
	robot.ScreenCurrentRectangleSetAsArbitrary(m(0) - w,m(1)-h,2*w,2*h)
	img  = robot.ScreenCaptureAsByteArray
	astream.Write(img)
End Sub